SystemOrganization addCategory: #LogBook!

Object subclass: #LogBook
	instanceVariableNames: 'date aircraft from to pic passenger uptime downtime airtime flighttime remarks'
	classVariableNames: 'LogBookData'
	poolDictionaries: ''
	category: 'LogBook'!

LogBook class
	instanceVariableNames: 'airtime'!

!LogBook commentStamp: 'bruceprior 7/29/2012 13:12' prior: 0!
I started this project on 29 Jul 2012.
A LogBook is a simple database modeled after the address database in the Seaside Book page 115.

Instance Variables
	airtime:		<Object>
	downtime:		<Object>
	flighttime:		<Object>
	from:		<Object>
	passenger:		<Object>
	pic:		<Object>
	remarks:		<Object>
	to:		<Object>
	uptime:		<Object>

airtime
	- xxxxx

downtime
	- xxxxx

flighttime
	- xxxxx

from
	- xxxxx

passenger
	- xxxxx

pic
	- xxxxx

remarks
	- xxxxx

to
	- xxxxx

uptime
	- xxxxx
!

LogBook class
	instanceVariableNames: 'airtime'!

!LogBook class methodsFor: 'adding' stamp: 'bruceprior 7/29/2012 13:52'!
addEntry: anEntry

	self entries add: anEntry
	! !

!LogBook class methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/30/2012 13:33'!
createSampleLogBook

^ OrderedCollection new
   add: (self date: '30 July 2012' aircraft: 'Cessna 190' from: 'Langley' to: 'Chillliwack' pic: 'B. Prior' passenger: 'J. Prior' uptime: '1220' downtime: '1250' airtime: 30 flighttime: 42 remarks: 'gorgeous flight!!');
   add: (self date: '16 June 2012' aircraft: 'Cessna 150' from: 'Chilliwack' to: 'Langley' pic: 'B. Prior' passenger: 'J. Prior' uptime: '1641' downtime: '1712' airtime: 31 flighttime: 43 remarks: 'Fun!!');
   yourself  ! !

!LogBook class methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/30/2012 13:35'!
date: dateString aircraft: aircraftString from: fromString to: toString pic: picString passenger: passengerString uptime: uptimeString downtime: downtimeString airtime: airtimeNumber flighttime: flighttimeNumber remarks: remarksString

^ self new
  date: dateString;   
  aircraft: aircraftString;
  from: fromString;
   to: toString;
   pic: picString;
   passenger: passengerString;
   uptime: uptimeString;
   downtime: downtimeString;
   airtime: airtimeNumber;
   flighttime: flighttimeNumber;
   remarks: remarksString;
   yourself.! !

!LogBook class methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/29/2012 13:50'!
entries

"Answers an Ordered Collection of the logbook entry instances."

  ^ LogBookData ifNil: [LogBookData := self createSampleLogBook ]! !

!LogBook class methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/30/2012 11:41'!
removeEntry: anEntry

	self entries remove: anEntry
	! !

!LogBook methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/30/2012 13:31'!
aircraft 
     ^aircraft ! !

!LogBook methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/30/2012 13:30'!
aircraft: aString 
     aircraft := aString! !

!LogBook methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/29/2012 13:20'!
airtime 
     ^airtime! !

!LogBook methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/29/2012 13:21'!
airtime: aNumber
     airtime := aNumber! !

!LogBook methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/30/2012 13:29'!
date
   ^date! !

!LogBook methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/30/2012 13:29'!
date: aString
   date := aString! !

!LogBook methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/29/2012 13:19'!
downtime 
     ^downtime! !

!LogBook methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/29/2012 13:20'!
downtime: aString 
     downtime := aString! !

!LogBook methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/29/2012 13:22'!
flighttime
     ^flighttime! !

!LogBook methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/29/2012 13:22'!
flighttime: aNumber
     flighttime := aNumber! !

!LogBook methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/29/2012 13:13'!
from
     ^from! !

!LogBook methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/29/2012 13:14'!
from: aString
     from := aString! !

!LogBook methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/29/2012 13:16'!
passenger
     ^passenger! !

!LogBook methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/29/2012 13:17'!
passenger: aString
     passenger := aString! !

!LogBook methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/29/2012 13:16'!
pic
     ^pic! !

!LogBook methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/29/2012 13:16'!
pic: aString
     pic := aString! !

!LogBook methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/29/2012 13:23'!
remarks
     ^remarks! !

!LogBook methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/29/2012 13:23'!
remarks: aString
     remarks := aString! !

!LogBook methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/29/2012 13:15'!
to
     ^to! !

!LogBook methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/29/2012 13:15'!
to: aString
     to := aString! !

!LogBook methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/29/2012 13:17'!
uptime 
     ^uptime! !

!LogBook methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/29/2012 13:18'!
uptime: aString 
     uptime := aString! !

WAComponent subclass: #LogBookFormView
	instanceVariableNames: 'entry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LogBook'!

!LogBookFormView class methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/31/2012 12:03'!
canBeRoot

^true.! !

!LogBookFormView class methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/31/2012 12:02'!
initialize

WAAdmin register: self asApplicationAt: 'logbookform'! !

!LogBookFormView methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/31/2012 11:44'!
entry

^ entry ifNil: [ entry:= LogBook entries first ]    "first line entry in LogBook"! !

!LogBookFormView methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/31/2012 11:30'!
entry: anEntry

entry := anEntry.! !

!LogBookFormView methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/31/2012 12:00'!
renderContentOn: html

html form: [
	html text: 'Date: '.
	html textInput
	       callback: [ :value | self entry date: value ];
	       value: self entry date.
	html break.
	html text: 'Aircraft: '.
	html textInput
	       callback: [ :value | self entry aircraft: value ];
	       value: self entry aircraft.
	html break.                  "Switch input coding to convenience method style. See Section 10.2"
	html text: 'From: '.
	html textInput on: #from of: self entry.
	html break.
	html text: 'To: '.
	html textInput on: #to of: self entry.
	html break.
	html text: 'PIC: '.
	html textInput on: #pic of: self entry.
	html break.
	html text: 'Passenger: '.
	html textInput on: #passenger of: self entry.
	html break.
	html text: 'Up Time: '.
	html textInput on: #uptime of: self entry.
	html break.
	html text: 'Down Time: '.
	html textInput on: #downtime of: self entry.
	html break.
	html text: 'Air Time: '.
	html textInput on: #airtime of: self entry.
	html break.
	html text: 'Flight Time: '.
	html textInput on: #flighttime of: self entry.
	html break.
	html text: 'Remarks: '.
	html textInput on: #remarks of: self entry.
	html break.
	
	html submitButton
	       callback: [ self save ];
	       value: 'Save' ]! !

!LogBookFormView methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/31/2012 12:17'!
save

self inform: self entry date , '--', self entry aircraft , '--', self entry from, '--', self entry to, '--', self entry pic, '--', self entry passenger, '--', self entry uptime, '--', self entry downtime, '--', self entry airtime, '--', self entry flighttime, '--', self entry remarks.! !

WAComponent subclass: #LogBookListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LogBook'!

!LogBookListView class methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/30/2012 11:30'!
canBeRoot
	"add LogBookListView to root applications in config."

^true.! !

!LogBookListView class methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/30/2012 11:42'!
initialize
	
    
    WAAdmin register: self asApplicationAt: 'logbook'
	! !

!LogBookListView methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/30/2012 14:20'!
addEntry

   | date aircraft from to pic passenger uptime downtime airtime flighttime remarks |

date := self request: 'Date'.
aircraft := self request: 'Aircraft'.
from := self request: 'From'.
to := self request: 'To'.
pic := self request: 'PIC'.
passenger := self request: 'Passenger'.
uptime := self request: 'Up Time'.
downtime := self request: 'Down Time'.
airtime := self request: 'Air Time'.
flighttime := self request: 'Flight Time'.
remarks := self request: 'Remarks'.

LogBook addEntry: (LogBook date: date aircraft: aircraft from: from to: to pic: pic passenger: passenger uptime: uptime downtime: downtime airtime: airtime flighttime: flighttime remarks: remarks)
! !

!LogBookListView methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/31/2012 10:56'!
removeEntry: anEntry

(self confirm: 'Are you sure that you want to remove this entry?')
ifTrue: [ LogBook removeEntry: anEntry ].! !

!LogBookListView methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/30/2012 12:13'!
renderContentOn: html
     
html anchor
     callback: [ self addEntry ];
           with: 'Add Entry'.

html unorderedList: [
		LogBook entries do: [ :entry |
		html listItem: [ self renderLogBook: entry on: html ]]]
! !

!LogBookListView methodsFor: 'as yet unclassified' stamp: 'bruceprior 7/31/2012 11:13'!
renderLogBook: anEntry on: html
     html 
render: anEntry date; render: ' ';
render: anEntry aircraft; render: ' ';
render: anEntry from; render: ' ';
render: anEntry to; render: '  ';
render: anEntry pic;  render:' ';
render: anEntry passenger; render: ' ';
render: anEntry uptime; render: ' ';
render: anEntry downtime; render: ' ';
render: anEntry airtime; render: ' ';
render: anEntry flighttime; render:' ';
render: anEntry remarks.
html text: '      ('.
html anchor
      callback: [ self removeEntry: anEntry ];
        with: 'Delete Entry'.
html text: ')'


! !
LogBookFormView initialize!
LogBookListView initialize!
